LeetCode 热题 HOT 100 1. 两数之和

题目描述:

     给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。

     你可以假设每种输入只会对应一个答案。但是,数组中同一个元素不能使用两遍。

示例1:

给定 nums = [2, 7, 11, 15], target = 9

因为 nums[0] + nums[1] = 2 + 7 = 9
所以返回 [0, 1]

解题思路:

1、使用hashMap:

      从头依次遍历nums数组,使用hashMap存储遍历过的元素(key)和所在位置(value),在访问nums[i],查询hashMap中是否存在target - nums[i],则说明nums中存在两个元素之和等于target,返回它们的位置即可。

时间复杂度和空间复杂度: 时间复杂度为O(N),空间复杂度为O(N)

实现代码:

class Solution {
    public int[] twoSum(int[] nums, int target) {
        if(nums == null || nums.length < 2)
            return new int[0];
        Map<Integer, Integer> map = new HashMap<>();//key存储元素,value存储位置
        int len = nums.length;
        int[] res = new int[2];
        for(int i = 0; i < len; i++){
            if(map.containsKey(target - nums[i])){
                res[0] = Math.min(i, map.get(target - nums[i]));
                res[1] = Math.max(i, map.get(target - nums[i]));
                break;
            }
            map.put(nums[i], i);
        }
        return res;
    }
}
上一篇:leetcode hot 100- 84. 柱状图中最大的矩形


下一篇:Webpack 常用Plugin